%define anolis_release 10

%{?perl_default_filter}
# Remove under-specified dependencies
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\((File::Spec|Perl::OSType)\\)$
 
Name:           perl-ExtUtils-CBuilder
# Compete with perl.spec
Epoch:          1
# Mimic perl.spec
Version:        0.280236
Release:        %{anolis_release}%{?dist}
Summary:        Compile and link C code for Perl modules
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/ExtUtils-CBuilder
Source0:        https://cpan.metacpan.org/authors/id/A/AM/AMBS/ExtUtils-CBuilder-%{version}.tar.gz
# Link XS modules to libperl.so with EU::CBuilder on Linux
Patch0:         ExtUtils-CBuilder-0.280230-Link-XS-modules-to-libperl.so-with-EU-CBuilder-on-Li.patch
BuildRequires:  perl(Cwd)
BuildRequires:  perl-devel
BuildRequires:  perl(strict)
BuildRequires:  perl(Config)
BuildRequires:  perl(IPC::Cmd)
BuildRequires:  perl(warnings)
BuildRequires:  perl-generators
BuildRequires:  perl(DynaLoader)
BuildRequires:  perl-interpreter
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(Text::ParseWords)
BuildRequires:  perl(Perl::OSType) >= 1
BuildRequires:  perl(File::Spec) >= 3.13
BuildRequires:  perl(Test::More) >= 0.47
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  make gcc gcc-c++ automake autoconf
Requires:       gcc
Requires:       gcc-c++
Requires:       perl-devel
Requires:       perl(DynaLoader)
Requires:       perl(Perl::OSType) >= 1
Requires:       perl(File::Spec) >= 3.13
Requires:       perl(ExtUtils::Mksymlists) >= 6.30
 
BuildArch:      noarch

%description
Perl-ExtUtils-CBuilder is a Perl module used for building and installing
C-based Perl modules. It is a part of the ExtUtils-Embed distribution and is
typically used in conjunction with other modules in the ExtUtils family, such
as ExtUtils-MakeMaker.

The module provides a simple interface for compiling and linking C code with
Perl, and it provides a number of convenience functions for common tasks, such
as finding system libraries and generating Makefile.PL files.

Some of the features of the Perl-ExtUtils-CBuilder module include:

Cross-platform support: The module is designed to work on a wide range of
platforms, including Linux, Windows, and macOS.

Automated build process: The module automates the process of building and
installing C-based Perl modules, making it easier for developers to create and
distribute their code.

Build customization: The module provides a number of options for customizing
the build process, such as specifying compiler flags and linker options.

Dependency management: The module includes tools for managing dependencies,
such as finding system libraries and checking for required software components.

Overall, Perl-ExtUtils-CBuilder is a valuable tool for developers who need to
build and distribute C-based Perl modules. Its simple interface and powerful
features make it an essential part of the ExtUtils family of modules.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness
 
%description tests
Tests from %{name}-%{version}. Execute them
with "%{_libexecdir}/%{name}/test".
 
%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n ExtUtils-CBuilder-%{version}
 
# Normalize shebangs
for F in t/*.t; do
    perl -MConfig -i -pe 's/\A#!.*perl/$Config{startperl}/' "$F"
    chmod +x "$F"
done
 
%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}
 
%install
%{make_install}
 
# Install tests
mkdir -p %{buildroot}/%{_libexecdir}/%{name}
cp -a t %{buildroot}/%{_libexecdir}/%{name}
cat > %{buildroot}/%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}/%{_libexecdir}/%{name}/test
 
%{_fixperms} %{buildroot}/*
 
%check
make test
 
%files
%license LICENSE
%{perl_vendorlib}/*
%{_mandir}/man3/*
 
%files tests
%{_libexecdir}/%{name}
 
%files doc
%doc Changes CONTRIBUTING README README.mkdn

%changelog
* Wed Apr 12 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.280236-10
- Update some description

* Thu Mar 23 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.280236-9
- Bump version to rebuild

* Mon Feb 13 2023 Funda Wang <fundawang@yeah.net> - 0.280236-8
- Link against libperl for downstream modules

* Tue Feb 07 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.280236-3
- remove versioned MODULE_COMPAT_ requires

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.280236-2
- rebuild with perl 5.36.0

* Wed Apr 20 2022 gcdota930915 <taifu.gc@alibaba-inc.com> - 0.280236-1
- Init from upstream version 0.280236
